#ifndef RUSANOV_EULERIAN_COMPOSITE_SOLVER_TOOLS_HPP
#define RUSANOV_EULERIAN_COMPOSITE_SOLVER_TOOLS_HPP

#include <mesh/MeshVariant.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>
#include <scheme/IBoundaryConditionDescriptor.hpp>

#include <memory>
#include <vector>

namespace toolsCompositeSolver
{
template <class Rd>
double EvaluateMaxEigenValueTimesNormalLengthInGivenDirection(   // const double& rho_mean,
  const Rd& U_mean,
  // const double& E_mean,
  const double& c_mean,
  const Rd& normal);

template <class Rd>
std::pair<double, double> EvaluateMinMaxEigenValueTimesNormalLengthInGivenDirection(const Rd& U_mean,
                                                                                    const double& c_mean,
                                                                                    const Rd& normal);

// template<class Rpxd>
// Rpxd Flux(const double& Rho, const Rd& u, const R& E, )

double compute_dt(const std::shared_ptr<const DiscreteFunctionVariant>& u_v,
                  const std::shared_ptr<const DiscreteFunctionVariant>& c_v);

}   // namespace toolsCompositeSolver

#endif
